<?php
/**
 * Created by PhpStorm.
 * User: wuxiande
 * Date: 2019/7/17
 * Time: 15:13
 */


require'./App/Predis/autoload.php';

class MonitorAction extends Action
{

    public function devices()
    {
        $limitRtimeout=30;
        $limitCpu=0.9;
        $limitMem=0.9;

        $server = array(
            'host' => '192.168.200.134',
            'port' => 6000,
        );
        $options = array(
            'parameters' => array(
                'password' => 'atomicytl',
            ),
        );

        $sql = "SELECT id,code,name,ip"
            ." FROM sh_hotel_device"
            ." WHERE status<2 "
            ." ORDER BY id ASC;";
        $Devices = D("")->query($sql);
        $values="";
        foreach ($Devices as $device){
            $values.="\"".$device["code"]."\",";
        }
        $values=rtrim($values,",");

//        var_dump($values);exit;


        $redis = new Predis\Client($server,$options);
        $script_D = $this->makeLuaScript("LDR",$values);
        $script_S = $this->makeLuaScript("LSR",$values);
        $mDeviceData = $redis->eval($script_D,0);
        $mServiceData = $redis->eval($script_S,0);

//        var_dump($mDeviceData);
//        echo "<br/>";
//        var_dump($mServiceData);
//        exit;


        foreach ($Devices as $k=>&$device){

                $device["dinfo"]=json_decode($mDeviceData[$k]); //设备监控信息
                $device["sinfo"]=json_decode($mServiceData[$k]); //设备监控信息

                $device["status"] = 0; //0正常,1服务汇报超时,2设备汇报超时,3,设备超负载,其他未知
                $device["reason"] = "正常";

                $mTime = $device["sinfo"]->t;
                if ($mTime+$limitRtimeout < time()){
                    $device["status"] = 1; //0正常,1服务汇报超时,2设备汇报超时,3,设备超负载,其他未知
                    $device["reason"] = "服务汇报超时";
                }
                $device["lst"]= date( "Y-m-d H:i:s",$mTime) ; //汇报时间
                $mTime = $device["dinfo"]->t;
                if ($mTime+$limitRtimeout < time()){
                    $device["status"] = 2;
                    $device["reason"] = "设备汇报超时";
                }
                //判断负载

        }


        echo json_encode($Devices);

    }

    function makeLuaScript($key,$values){
        $script ="local d = redis.call(\"hmget\",\"$key\", $values)"
        ." local r = {}"
        ." for k,v in ipairs(d)"
        ." do"
            ." if v then r[k] = cjson.encode(cmsgpack.unpack(v)) else r[k]=cjson.encode(nil) end"
        ." end"
        ." return r";

    //    echo $script;exit;
        return $script;
    }

    function HttpPost($url,$param){

        $ch = curl_init();
        //如果$param是数组的话直接用
        curl_setopt($ch, CURLOPT_URL, $url);
        //如果$param是json格式的数据，则打开下面这个注释
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($param))
        );
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        //如果用的协议是https则打开鞋面这个注释
        // curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        // curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);

        $data = curl_exec($ch);

        curl_close($ch);
        return $data;

    }

}